// C Header File
// Created 26.12.2003; 22:38:16
/*Fichier commun pour editeur et pingpong*/
//POKE 0xCB sur le timer pour avoir 20 ticks = 1 seconde.

#define TABLE_X			50
#define TABLE_Y			50
#define BOULES_MAX		20
#define RAQS_MAX		20
#define Erreur(shane) DlgMessage("ERREUR",shane,BT_CANCEL,BT_NONE)
#define Message(chaine) (message=chaine, tempsMessage=50)
#define RegleTimer(valeur)	(timer=valeur)
#define ValeurTimer()		(timer)
#define TimerExpire()		(timer<=0)
#define NBRE_NIVEAUX_NORMAUX	32
#define NBRE_NIVEAUX_TOTAUX		36

enum touches {HOME=277,ESC=264,APPS=265};

typedef unsigned char car;
car *ecran=NULL;//, *ecranHome=NULL;

INT_HANDLER ai1, ai5;

typedef struct
{
	int  x;
	int  y;
	char angle;

	int  cpt;					//Modulo 2
	char valide;
	int  tps;

	char pouvoir;
	char vitesse;
} BALLE;

typedef struct
{
	int  pos;  /*position (x ou y)*/
	char mode; /*1=horiz. 2=vert.*/
} RAQUETTE;

enum types {NORMAL=0,LOURD=1};

short min,sec,ms;
short niv;
int vies, continues;
int bonus;
short nEl,raqs;
unsigned long score, borderLineCourante;
/*Dimensions de la map*/
int dimX=15, dimY=16;
/*Puissance sup.*/
int pui;
/*Coins de l'cran*/
int ecrX=0, ecrY=0;
/*Pour le dfilement*/
int scrlX, scrlY, baseX, baseY;
int ersteFrame;
/*La boule tourne avant d'tre lance*/
int initial;
/*Actif ou non*/
int defil, defilX, defilY;
/*Certaines tches du jeu sont suspendues*/
int suspendu;
int editeur;
/*Variables de pouvoir spciaux*/
int nPouvoir, nPouvoirType;
int nMessage;
long msgargs[5];
short hw;

/*Matrice principale*/
car (*m)[TABLE_X]=0L;

/*Positions de la raquette*/
int raq=16, raqY=72;

//Permet de signaler des messages  la fonction principale
enum messages {MSG_AUCUN, MSG_CREEBALLE, MSG_CREERAQUETTEH, MSG_CREERAQUETTEV};


volatile int timer;

DEFINE_INT_HANDLER(IntTimer)	{
	if (timer>0)
		timer--;
}

#define RegleTimer(valeur)	(timer=valeur)
#define ValeurTimer()		(timer)
#define TimerExpire()		(timer<=0)
#define MFS 10

void attend(short t)
{
	RegleTimer(t);
	while (!TimerExpire()) idle();
}


/*CALLBACK void TempHook(EVENT *ev)
{
	if (ev->Type!=CM_KEYPRESS) return;

	int k = ev->extra.Key.Code;
	if (k==4360)
		ER_throwVar(1);
}*/

void DessRctgle()		{
	unsigned short *ptr=(unsigned short *)ecran;
	short y,x;
	for (y=0;y<100;y++)		{
		for (x=160/16;x<240/16;x++)
			*(ptr+x)=0xffff;
		ptr+=240/16;
	}
}

void CopieEcran(LCD_BUFFER ecran)		{
	if (CALCULATOR)		{
		DessRctgle();
		memcpy(LCD_MEM+40/8+13*30,ecran,100*30);
	}
	else	{
		memcpy(LCD_MEM,ecran,100*30);
	}
}

//Affiche un cran et effectue les tches standardes, comme le contraste et l'appel  l'cran HOME
void Home(char *ecran)		{
	if (_keytest(RR_PLUS))		{
		OSContrastUp();
		while (_keytest(RR_PLUS));
	}
	if (_keytest(RR_MINUS))		{
		OSContrastDn();
		while (_keytest(RR_MINUS));
	}

/*	if (_keytest(RR_HOME))		{
		EVENT_HANDLER temp;
		temp = EV_hook;
		PortRestore();
		SetIntVec (AUTO_INT_1, ai1);
		SetIntVec (AUTO_INT_5, ai5);
		EV_hook = TempHook;
		LCD_restore(ecranHome);
		pushkey(263);
		TRY
			EV_eventLoop ();
		ONERR
		ENDTRY
		LCD_save(ecranHome);
		LCD_restore(ecran);
		PortSet(ecran,239,127);
		SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
		SetIntVec(AUTO_INT_5,IntTimer);
		EV_hook = temp;
		attend(10);
		RegleTimer(MFS);
#ifndef TRICHE
		if (hw==1)
			pokeIO(0x600017,0xB2);
		else if (hw==2)
			pokeIO(0x600017,0xD0);
#endif
		while(_keytest(RR_ESC) || _keytest(RR_2ND));
	}*/
	CopieEcran(ecran);
}

//int frameNb=0;

#define FRAME_SKIP_NONSYNCHRO

#ifdef FRAME_SKIP_SYNCHRONISE
	void nvelleFrame (short *skip, short *att)	{
		if (!(*skip))
			RegleTimer(MFS+*att);
		*att=0;
	}

	void frameSkip (short *skip, short *att)	{
		short i;
		if (*skip) {
			(*skip)--;
			*att=0;
			if (*skip)
				return;
			else
				*att=1;
		}

		i=ValeurTimer();
		if (i<=MFS-1) {
			*skip=MFS-i;
			RegleTimer(MFS);
		}
		else {
			*skip=0;
			if (!(*att))	{
				while (ValeurTimer()>MFS-1)	idle();
			}
		}
	}
#endif

#ifdef FRAME_SKIP_NONSYNCHRO
	void nvelleFrame (short *skip, short *att)	{
/*		frameNb++;
		if (frameNb%2!=0)
			RegleTimer(MFS+1);
		else*/
			RegleTimer(MFS);
	}

	void frameSkip (short *skip, short *retard)	{
		if (*skip) {
			(*skip)--;
		}

		(*retard)--;
		*retard+=MFS-ValeurTimer();

		if (*retard>=2)		{
			(*skip)++;
		}

		if (*retard<=0)	{
			(*retard)++;
			while (ValeurTimer()>MFS-1)	idle();
		}
	}
#endif

#ifdef FRAME_SKIP_BASSE_RESSOURCES
	void nvelleFrame (short *skip, short *att)	{
		RegleTimer(MFS);
	}

	void frameSkip (short *skip, short *retard)	{
		short i=0;

		if (*skip) {
			i=1;
			(*skip)--;
		}

		(*retard)--;
		if (i==0)
			*retard+=MFS-ValeurTimer();

		if (*retard>=2)		{
			(*skip)++;
		}

		if (*retard<=0)	{
			(*retard)++;
			while (ValeurTimer()>MFS-1)	idle();
		}
	}
#endif


#define fopenr(fichier)		(get_ptr(get_entry(fichier))+2)

char *mk_nam(const char *str)
{
	static char name[19] = {0} ;
	short len = strlen(str) ;

	if (len > 17) return NULL ;

	return strcpy(name+1, str)+len ;
}

SYM_ENTRY *get_entry(const char *str)
{
	char *nom = mk_nam(str) ;
	return SymFindPtr(nom, 0) ;
}

char *get_ptr(SYM_ENTRY *entry)
{
	if (entry == NULL || entry->handle == H_NULL) return NULL ;
	return (char*)HeapDeref(entry->handle) ;
}

/*Rinitialise les variables globales pour une nouvelle partie*/
void initGlobales()
{
	defilX=(dimX>10);
	defilY=(dimY>12);
	defil=(defilX || defilY)?1:0;
	raq=78;
	raqY=72+8*(dimY-12);
	scrlX=0;
	scrlY=defil;
	baseX=1;
	baseY=dimY-11;
	ersteFrame=1;
	initial=1;
	suspendu=0;
	pui=0;
	nPouvoir=nPouvoirType=0;
}

int alloc()	{
	if (!ecran)
		ecran=malloc(LCD_SIZE);
	if (!m)
		m=malloc(TABLE_X*TABLE_Y);
	if (!ecran || !m)
		return 0;
	memset(m,0,TABLE_X*TABLE_Y);
	return 1;
}

void libere()	{
	if (ecran)
		free(ecran), ecran=NULL;
	if (m)
		free(m), m=NULL;
}

/*Affiche la map du tableau en cours*/
void afficheTableau()
{
	int c,x,y;

	//Affichage de l'arrire-plan (les briques)
	for (y=0;y<=12;y++)	{
		for (x=0;x<=10;x++) {
			c=m[baseX+x][baseY+y];
			if (x+baseX<0 || y+baseY<0)  continue;
			if (c==1)
				ClipSprite16_OR_R(16*x-scrlX,8*y-scrlY,7,plein,ecran);
			else if (c==2)
				ClipSprite16_OR_R(16*x-scrlX,8*y-scrlY,7,bloc,ecran);
			else if (c==3)
				ClipSprite16_OR_R(16*x-scrlX,8*y-scrlY,7,blocGris,ecran);
			else if (c==4)
				ClipSprite16_OR_R(16*x-scrlX,8*y-scrlY,7,blcAcier,ecran);
			else if (c==5)
				ClipSprite16_OR_R(16*x-scrlX,8*y-scrlY,7,blcSpe,ecran);
			else if (c>=16 && c<=23) {
				c-=16;
				ClipSprite16_OR_R(16*x-scrlX,8*y-scrlY,8,Special+8*c,ecran);
			}
			else if (c>=32 && c<=33)	{
				c-=32;
				ClipSprite16_OR_R(16*x-scrlX,8*y-scrlY,7,blcPouvoirs+7*c,ecran);
			}
			else if (c==49 && !editeur && !nMessage)	{
				nMessage=MSG_CREERAQUETTEH;
				msgargs[0]=8*(y+baseY);
				m[baseX+x][baseY+y]=0;
			}
			else if ((c==50 || c==51) && !editeur && !nMessage)	{
				nMessage=MSG_CREERAQUETTEV;
				msgargs[0]=16*(x+baseX);
				if (c==51)
					msgargs[0]+=8;
				m[baseX+x][baseY+y]=0;
			}
			else if (c>=64 && c<128)	{
				c-=64;
				ClipSprite16_OR_R(16*x-scrlX,8*y-scrlY,8,patterns+8*c,ecran);
			}
		}
	}
}

/*Ramne un angle dans le cercle trigonomtrique*/
int _360(int a)
{
	return ((a-1)%12)+1;
}

int rebondit(short a,short mn,short mx)
{
	if (a>=7 && a<=9)
		a=19-a;
	else if (a>=4 && a<=6)
		a=7-a;
	/*Pour donner de l'effet  la boule*/
	if (mn && a>=10)
		a=10;
	if (mn && a<=3)	{
		if (a!=2)
			a=11;
		else
			a=12;
	}

	if (mx && a<=3)
		a=3;
	if (mx && a>=10)	{
		if (a!=11)
			a=2;
		else
			a=1;
	}
	return a;
}

void trembleEcran()
{
	suspendu=1;
	initial+=2;
	if (initial==2)
		scrlX-=2;
	if (initial<=24) {
		if (initial%8==2)
			scrlX+=4;
		else if (initial%8==6)
			scrlX-=4;
	}
	else if (initial==26)
		scrlX+=2;
}

void afficheScore ()
{
	char str[100];
	char mode;
	while (ms>=19) {
		sec++;
		ms-=19;
	}
	while (sec>=60) {
		min++;
		sec-=60;
	}
	FontSetSys(0);
	sprintf(str,"O= %i",vies);
	DrawStr(0,95,str,4);
	sprintf(str,"%06lu",score);
	DrawStr(45,95,str,4);
	sprintf(str,"% 2i%c%02i",(min<100)?(min):(min/60),((min<100)?((ms>=10)?(' '):(':')):((min<10*60)?('h'):('\''))),(min<100)?(sec):(min%60));
	DrawStr(141,95,str,4);
	niv--;
	sprintf(str,"%i-%i",niv/4+1,niv%4+1);
	niv++;
	DrawStr(100,95,str,4);

 /* sprintf(str,
   "%02i%%",100-util/12);
  DrawStr(143,95,str,4);*/
}

/*Affiche la balle*/
void afficheBalle(BALLE *s)
{
	if (s->pouvoir==0)
		ClipSprite8_OR_R (s->x-ecrX,s->y-ecrY,8,balleNoire,ecran);
	else
		ClipSprite8_OR_R (s->x-ecrX,s->y-ecrY,8,balle,ecran);
}

/*Bouge la balle dans la direction indique par son 'angle'*/
void bougeBalle(BALLE *s)
{
	/*
	Orientation des pices en fonction de leur angle
	   1: haut  droite-
	   2: haut  droite
	   3: haut- droite
	   4: bas - droite
	   5: bas   droite
	   6: bas   droite-
	   7: bas   gauche-
	   8: bas   gauche
	   9: bas - gauche
	  10: haut- gauche
	  11: haut  gauche
	  12: haut  gauche-
	En fait a reprsente les angles des aiguilles d'une montre.
	*/
	int a;
	while (s->angle<1)
		s->angle+=12;
	while (s->angle>12)
		s->angle-=12;
	a=s->angle;
	s->cpt=1-(s->cpt);

	if (a==1 || a==2 || a==11 || a==12)
		s->y--;
	if ((a==3 || a==10) && s->cpt)
		s->y--;

	if (a>=5 && a<=8)
		s->y++;
	if ((a==4 || a==9) && s->cpt)
		s->y++;

	if (a>=2 && a<=5)
		s->x++;
	if ((a==1 || a==6) && s->cpt)
		s->x++;

	if (a>=8 && a<=11)
		s->x--;
	if ((a==7 || a==12) && s->cpt)
		s->x--;
	if (s->y>=8*dimY || s->x>16*dimX+16 || s->x<0 || s->y<0)
		s->valide=0;
}

car ouvreFichier(const car *nom,unsigned long n);

short gains[4]={150,300,450,300};

unsigned long calcBorderLine ()		{
	unsigned long borderLine=0;
	int a, b;
	for (b=0;b<dimY;b++) {
		for (a=0;a<dimX;a++) {
			if (m[a+1][b+1]>=2 && m[a+1][b+1]<=5)
				borderLine+=gains[m[a+1][b+1]-2];
			if (m[a+1][b+1]>=19 && m[a+1][b+1]<=22)
				borderLine+=100;
		}
	}
	borderLine+=1000;
	return borderLine;
}

unsigned long calcBorderLineTotale (const char *nom, car jusqua)		{
	int n=1;
	unsigned long scoremax=0;
	for (n=1;n<=jusqua;n++)		{
		ouvreFichier(nom,n);
		scoremax+=calcBorderLine();
	}
	return scoremax;
}

car ouvreFichier(const car *nom,unsigned long n)
{
	car *ptr;
	car c, motif;
	int a,b, i,j;
	unsigned long nv;
	nEl=0;
	if (nom==NULL)
		ptr=tableaux;				//Niveaux par dfaut
	else
		ptr=fopenr(nom);
	if (!ptr) return 0;

	if (nom!=NULL)					//Passer l'en-tte
		ptr+=3;

	nv=1;
	while (*ptr && nv<n) {
		if (*ptr++=='')
		nv++;
	}
	if (nv<n)	{
		printf_xy(0,0,"nv<n");
		ngetchx();
		return 0;
	}
	c=*ptr++;
	dimX=c-32;
	c=*ptr++;
	dimY=c-32;
	c=*ptr++;
	raqs=c-32;

	if (dimX>TABLE_X-2 || dimY>TABLE_Y-2 || raq<=0)		{
		printf_xy(0,0,"dim. invalides");
		ngetchx();
		return 0;
	}
	if (*ptr!='\r')		{
		printf_xy(0,0,"%i %i %i %i",*(ptr-2),*(ptr-1),*ptr,*(ptr+1));
		ngetchx();
		return 0;
	}

	if (nom==NULL)
		ptr++;
	else
		ptr+=2;
	if (!alloc())
		return 0;
	for (b=0;b<=dimY;b++) {
		for (a=0;a<=dimX;a++) {
			c=*ptr;
			if (c==0 || c==16 || c==22)
				break;
			if (c=='\r') {
				if (nom==NULL)
					ptr++;
				else
					ptr+=2;
				break;
			}
			if (c==17)	{
				ptr++;
				motif=(*ptr++)-32;
				i=a;
				a+=(*ptr++)-31;
				for (j=i;j<a;j++)	{
					if (motif>=2 && motif<=15)
						nEl++;
					m[j+1][b+1]=motif;
				}
				a--;
				continue;
			}
			if (c==18) {
				ptr++;
				c=*ptr++;
				a+=c-32;
				continue;
			}
			c-=32;
			if (c>=2 && c<=15)
				nEl++;
				m[a+1][b+1]=c;
				ptr++;
		}
	}
	return 1;
}

